//----------------------------------------------------------------------
//29 Feb 2000
//----------------------------------------------------------------------





#include "decomp.h"
#include "strings.h"
#include "labels.h"
#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>

//this table hold the count of the number of args that the
//function it refers to takes
//variable function positions are included as a place holder
//but the count for the variable is -1 which means it is not from the table
// but from the byte following the function token in the raw stream
//of data read in from disk.
char codeTable[] =
{   //elements 0 to 66 relate to codes 31 to 97
	0, //31 na
	0, //32 err
	1, //33 abs
	1, //34 int
	1, //35 sqrt
	1, //36 log
	1, //37 ln
	0, //38 pi
	1, //39 sin
	1, //40 cos
	1, //41 tan
	1, //42 atan2
	1, //43 atan
	1, //44 asin
	1, //45 acos
	1, //46 exp
	2, //47 mod
	-1, //48 choose  var
	1, //49 isna
	0, //50 ignore  (token unused)
	0, //51 false
	0, //52 true
	0, //53 rand
	3, //54 date
	0, //55 today
	3, //56 pmt
	3, //57 pv
	3, //58 fv
	3, //59 if
	1, //60 day
	1, //61 month
	2, //62 round (probably another name)
	2, //63 round (real token for round )
	0, //64 unused
	0, //65 unused
	0, //66 unused
	0, //67 unused
	0, //68 unused
	0, //69 unused
	0, //70 unused
	0, //71 unused
	0, //72 unused
	0, //73 unused
	0, //74 unused
	0, //75 unused
	0, //76 unused
	0, //77 unused
	0, //78 unused
	0, //79 unused
	-1, //80 sum    var
	-1, //81 avg    var
	-1, //82 cnt    var
	-1, //83 min   var
	-1, //84 max   var
	3, //85 vlookup
	2, //86 npv
	1, //87 var
	1, //88 std
	2, //89 irr
	3, //90 hlookup
	-1, //91 dsum  database stat   var
	-1, //92 avg   database stat
	-1, //93 dcnt  database stat var
	-1, //94 dmin  database stat var
	-1, //95 dmax   database stat var
	1, //96 dvar    database stat
	1, //97 dstd    database stat
	-2   //end of list marker
};

Token tokenList[] =
{

 //formula Opcode followed untokenised version as a string

 //code   Operation          Description
	0,    "",       //Code is followed by an 8 byte
									//IEEE Long Real Floating Point
									//Number

  1,   "",          //Code followed by 4 byte coor-
									 //dinate Byte 0,1 = Column
									 //Byte 2,3 = Row

  2, "",               //Code followed by 8 byte range
									 //Byte 0,1 = Start column
									 //Byte 2,3 = Start row
									 //Byte 4,5 = End column
									 //Byte 6,7 = End row

  3, "",              //End of formula

  4, ")",         //Indicates presence of paren-
									 //theses in original formula.
									 //It is ignored during recal-
									 //culation.

  5, "",                   //2 byte signed constant integer.

 //The above Opcodes will define the type and length of information that
 //follows the Opcode.  Opcode 3 defines the end of the formula.

 //For example, Opcode 0 is followed by an 8 byte floating point number.
 //				  Opcode 1 is followed by a 4 byte coordinate.
 //				  Opcode 2 is followed by an 8 byte range specifier.
 //				  Opcode 5 is followed by a 2 byte signed integer.

  6, "",
  7, "",

  8, "-",						//unary -
  9, "+",                 //Addition
 10, "-",                 //Subtraction
 11, "*",                 //Multiplication
 12, "/",                 //Division
 13, "^",                 //Exponentiation;
								  //						 ie. 3^2 is(3x3)
 14, "=",                 //Equal to
 15,"<>",                 //Not equal to
 16, "<=",                //Less than or equal to
 17, ">=",                 //Greater than or equal to
 18, "<",                 //Less than
 19, ">",                 //Greater than
 20, "#AND#",             //Logical AND
 21, "#OR#",              //Logical OR
 22, "#NOT#",             //Logical NOT
 23, "+",                //unary +  (Ignored during recalculation)
 24, "",
 25, "",
 26, "",
 27, "",
 28, "",
 29, "",
 30, "",
 31, "na()",                //@Na not applicable
 32, "err()",               //@Err error
 33, "abs",               //@abs (x) Absolute value of x
 34, "int",               //@int (x) Integer value of x
 35, "sqrt",              //@sqrt (x) Square root of x
 36, "log",               //@log (x) Log base 10 of x
 37, "ln",                //@ln (x) Log base e of x
 38, "pi()",                //@pi
 39, "sin",               //@sin (x) Sine of x
 40, "cos",               //@cos (x) Cosine of x
 41, "tan",               //@tan (x) Tangent of x
 42, "atan2",             //@atan2 (x) 4 quadrant arc tangent
								  //						 of x
 43, "atan",              //@atan (x) 2 quadrant arc tangent
								  //						 of x
 44, "asin",              //@asin (x) Arc sine of x
 45, "acos",              //@acos (x) Arc cosine of x
 46, "exp",               //@exp (x) Exponential anti-log of x
 47, "mod",               //@mod (x,y)X Mod Y
 48, "sel",               //@Choose (x,v0,v1...vN)
								  //					  Match a list item.
 49, "isna",              //@isna (x)x = NA then 1 (true)
 50, "",
 51, "false()",             //@false Return 0
 52, "true()",              //@true Return 1
 53, "rand()",              //@rand Generate random number
								  //					 between 0 and 1
 54, "date",              //@date (Y,M,D) Generate the days
								  //					 since 1/1/1900 (Y = 0-199,
								  //					 M = 1-12, D = 1-31)
 55, "today()",             //@today  Output serial date number
								  //					 from cpu's clock
 56, "pmt",               //@pmt (princ, int, term)Payment
 57, "pv",                //@pv (pmt, int, term) Present value
 58, "fv",                //@fv (pmt, int, term) Future Value
 59, "if",                //@if (argument, them else) Boolean
								  //						if
 60, "day",               //@day (x) Print day of the month from
								  //						a serial date number
 61, "month",             //@month (x) Print month of the year
								  //						from a serial date number
 62, "round",             //@round (x,d) Round number x to d
								  //						decimal places


 63, "round",             //@round (x,d) Round number x to d
								  //						decimal places
 64, "",
 65, "",
 66, "",
 67, "",
 68, "",
 69, "",
 70, "",
 71, "",
 72, "",
 73, "",
 74, "",
 75, "",
 76, "",
 77, "",
 78, "",
 79, "",
 //The above Opcodes are variable, constant and argument related.

 //For example: @sqrt (9) is the square root of the constant 9
 //				 @sqrt (A1) is the square root of the variable A1
 //				 @sqrt ((A1*2)/3) is the square root of the argument (A1*2)/3
 //					(Note that the argument ((A1*2)/3) will be processed before
 //               the @sqrt function.)

 //Formula Opcodes for Multiple Arguments


 80, "sum",              //@sum (range and/or cell and/or
								 //				  constant) Use commas to separate
								 //				  arguments
 81, "avg",              //@avg (range and/or cell and/or constant)
								 //				  Use commas to separate arguments
 82, "cnt",              //@cnt (range and/or cell and/or constant)
								 //				  Use commas to separate arguments
 83, "min",              //@min (range and/or cell and/or constant)
								 //				  Use commas to separate arguments
 84, "max",              //@max (range and/or cell and/or constant
								 //				  Use commas to separate arguments
 85, "vlookup",          //@Vlookup (x, range, offset) X = Cell
								 //				  address or constant, range = Table,
								 //				  Offset = Row in Table
 86, "npv",              //@npv (int, range) Net present value;
								 //				  Int = interest, Range = cash flows
 87, "var",              //@var (range) Variance of all items in
								 //				  list
 88, "std",              //@std (range) Standard deviation of all
								 //				  items in list
 89, "irr",              //@irr (guess,range) Guess = % estimate;
								 //				  Range = range of cash flows
 90, "hlookup",          //@hlookup, (x, range, offset) X = Cell
								 //				  address or constant, range = Table,
								 //				  Offseet = row in Table
 91, "dsum",             //Database statistical functions
 92, "avg",              //Database statistical functions
 93, "dcnt",             //Database statistical functions
 94, "dmin",             //Database statistical functions
 95, "dmax",             //Database statistical functions
 96, "dvar",             //Database statistical functions
 97, "dstd",              //Database statistical functions

 0, "\0"
};

 //The above Opcodes deal specifically with ranges and multiple arguments.
 //For example: @sum (A1...A10, B25, 9) contains a range, a variable and a
 //constant as the arguments.

 //	  All function Opcodes which accept a variable number of arguments
 //	  are followed by a 1-byte argument count.
//--------------------------------------------------------------------------


//Constructor
Decomp::Decomp()
{
	unsigned int t, odd;

	stack = new Symb[MAXSTACK];    //ptr to an array of type Symb
											 //declared on the free store.

	postfix = new Symb[MAXSYMB];


	tos = -1;    //reset top of stack to indicate empty stack

	for(t =0; t<26; t++) colwidths[t] =10;
	sheet = new ScreenCell[2600*4];
	odd =0;

	//create a temporary array to hold the cells properties
	//for a max sheet of 26 cols by 800 rows

	for(t = 0; t< 2600*4; t++)
	{
		if(t%26 == 0) odd = !odd;
		if(odd)
			sheet[t].u.colour = LIGHTGRAY*16+BLACK;
		else
			sheet[t].u.colour = CYAN*16+BLACK;

		sheet[t].u.decplaces =2;
		sheet[t].u.allign = 0;     //default allign
		sheet[t].u.commas =0;     //no commas yet
		sheet[t].u.locked =0;     //not locked yet
		sheet[t].u.percent =0;   //no percent
		sheet[t].u.type =0;       //cell empty

	}

}
//--------------------------------------------------------------------------
//de structor.
Decomp::~Decomp()
{
	delete [] sheet;
	delete [] postfix;    //free up the previously allocated memory
	delete [] stack;

}
//-------------------------------------------------------------------------

int Decomp::IsStackEmpty()
{
	return tos == -1;

}
//--------------------------------------------------------------------------
//Push a symbol on the stack
//Return true of successful
int Decomp::Push(Symb *symb)
{
	if(tos+1 == MAXSTACK) return 0;    //unsuccessful

	stack[++tos] = *symb;

	return 1; //successful

}
//-------------------------------------------------------------------------
//Return addr of an item poped from the top
// of the stack
Symb *Decomp::Pop()
{
	if(tos == -1) return NULL;    //stack enpty

	tempsymb = stack[tos--];      //pop current item from stack,
											//dec'ing tos pointer afterwards

	return &tempsymb;
}
//-------------------------------------------------------------------------
//Copy into buf the appearance of the operator, operand or function
//based on the value that opcode has. Use the same codes as Lotus1-2-3
//Exit:
// ax = the len of the appearance string in buf
//       ax =0 if opcode has no appearance

int Decomp::GetAppearanceOfOpCode(char *buf, unsigned char opcode)
{
	int t, len;
	if(opcode <4 || (opcode >= 24 && opcode <=30) || opcode ==50 ||
		 (opcode >= 64 && opcode <=79) || opcode >97)
	 {
		buf[0] =0;
	 }

	else
		strcpy(buf, tokenList[opcode].text);
	//in case the opcode has no appearance, for example if it
	//refers to an operand following it then clear the string in buf


	 if((opcode >=31 && opcode <=97) && buf[0])
	 {
		  //convert the function name to upper case
		  len = strlen(buf);
		  for( t=0; t< len; t++)
			  buf[t] = toupper(buf[t]);


		  //prefix the function name with a '@'
		  s.InsertChar(buf, '@', 0);    //at pos 0
	 }




	return strlen(buf);
}
//-------------------------------------------------------------------------
//The entry code must be either 0 or 5
// If its 0 it means convert double to string
//If its 5 it means convert integer to string
//If it is anything else return an empty buffer
int Decomp::GetAppearanceOfNumber(char *buf, unsigned char opcode,
											 int inum, double dnum)

{
	int t;
	char *p;

	switch(opcode)
	{
		case 0:      //convert double to a string
			sprintf(buf, "%lf",dnum);
			//remove all right most zero digits if the occure after decimal
			//point except
			p = strchr(buf, '.');
			if(p)
			{
				t = strlen(buf) -1;  //found '.' point to last digit

				if(buf[t] != '0') goto brk;
				while(buf[t] == '0') t--;

				t++; //point to zero digit

				//the char behind t is either '.' or a non zero digit
				if(buf[t] == '0' && buf[t-1] == '.')
					buf[t-1] =0; //all zeros after decimal point so delete
					//the decimal point and all the following zero digits.

				else
				//The char pointed to by t is a zero digit but the
				//char behind it is not a '.' but a non zero digit so
				//shorted the buffer keeping the last non-zero digit
				//after the decimal point
					buf[t] =0;

			}
brk:
			break;


		case 5:
			sprintf(buf, "%d", inum);
			break;

		default:
			buf[0] =0;
			break;

	}

	return strlen(buf);
}
//-------------------------------------------------------------------------
//Get the appearance of a variable  and store that appearance in buf
//for example it might look like "A1" or "AB34"
//or $A$1
//if the col is negative it is relative to
// cell_col. If its positive its absolute.
// if src_cell = 1 it means the col, row is a source cell, the location
//that holds a formula, therefore don't place absolute symbols
//in between col and row characters.
int Decomp::GetAppearanceOfVariable(char *buf, int col,
												int row, int src_cell)
{

	int pos = 0;
	int vcol = col, vrow = row;

	if(src_cell)   //if its a source cell, rather than a reference cell variable
	{
		pos = 1;
		buf[0] = col+'A';
		if(col >=26)
		{
			buf[0] = (col/26)+'A'-1;
			buf[1] = (col%26)+'A';
			pos = 2;  //the c pos where the row number will begin from in the str
		}
		itoa(row+1, &buf[pos], 10);
		return strlen(buf);

	}
	//------

	if(vcol <0)  //because its not positive its a relative reference
						//to cell_col
	{

		vcol = vcol & 255;  //vcol = the relative value

		vcol += cell_col;
		vcol = (vcol & 255);

		if(vcol >=26)
		{
			buf[0] = (vcol/26)+'A'-1;
			buf[1] = (vcol%26)+'A';
			pos =2;  //pos where row # will begin
		}
		else
		{
			buf[0] = vcol+'A';
			pos =1;    //pos where row # will begin
		}

	}
	//else vcol is absolute, not relative
	else  //but is is still a var, not a src location
	{     //And because it is positive we must prefix the col letter with
			//the $ absolute symbol
		buf[0] = '$';
		if(vcol >=26)
		{
			buf[1] = (vcol/26)+'A'-1;
			buf[2] = (vcol%26)+'A';
			pos =3;  //pos where row # will begin
		}
		else
		{
			buf[1] = vcol+'A';
			pos =2;    //pos where row # will begin
		}

	}

	//By the time we get here we have stored the either a relative or
	//an absolute column letter (or 2 letters).
	//Now we must determine whether the row
	//is relative or absolute and store accordingly
	if(vrow <0) //its relative
	{
		vrow = vrow + cell_row;
		vrow = vrow & 8191;
		itoa(vrow+1, &buf[pos], 10);
		return strlen(buf);

	}

	//vrow is absolute
	buf[pos++] = '$';
	itoa(vrow+1, &buf[pos], 10);
	return strlen(buf);


}
//------------------------------------------------------------------------
//Refturn to the caller the appearance of a range
// It might look like this "A1:b1"
// colon = 1 if a colon is to be between the coordinates
// colon = 0 means use ".." instead
int Decomp::GetAppearanceOfRange(char *buf, int stcol,
															int strow,
															int endcol,
															int endrow,
															int colon)
{
	int len;

	GetAppearanceOfVariable(buf, stcol, strow);
	if(colon)
	  strcat(buf, ":");

	else
		strcat(buf, "..");

	len = strlen(buf);
	GetAppearanceOfVariable(&buf[len], endcol, endrow);

	return strlen(buf);
}
//------------------------------------------------------------------------
//Imagine a raw formula read in from a Lotus 1-2-3 spreadsheet file as it
//appears in "*.wks" format.
//Convert each distinct element of the
// formula to its symbol and store these symbols in the postfix symbol array
// To converting from postfix to infix is done at this stage. Only
//the raw data is converted to a symbol format that is easier to
// manipulate than the raw data.
//The end of the buf should contain the end of formula code (3)
//
//The raw codes in rawbuf should begin immediately after
//with the two byte len of the formula
//that appear on the disk, but this two byte len should not be in rawbuf
//
// colon = 1 by default which means in a range the colon will appear
//           if colon = 0 the ".." appears between coordinates in a range
int Decomp::ConvertRawToPostfix(char *rawbuf, int colon)
{


	int pos, t;
	unsigned char code, byte;
	int symbcount =0;
	int inum, stcol, strow, endcol, endrow;
	double dnum;

	pos = 0;
top:
	do{
		code = rawbuf[pos];
		pos++;  //point to next byte after code
		tempsymb.code = code;
		tempsymb.type = 3;  //assume it is an ignore code
								  //which means the symbol will be discarded
		switch(code)
		{
			case 0:    //an 8 byte double follows
			//copy in the 8 byte double
				for(t = 0; t <8; t++)
					tempsymb.u.text[t] = rawbuf[pos+t];

				dnum = tempsymb.u.dvalue;
				//store in the the string the appearance of that double
				GetAppearanceOfNumber(tempsymb.appearance, code, 0, dnum);
				pos+=8;
				tempsymb.type = 4;  //operand code
				break;


			case 1:      //variable: 4 byte cell coordinates follow
			//copy in the 4 byte variable
				for(t = 0; t <4; t++)
				{
					byte = rawbuf[pos+t];
					tempsymb.u.text[t] = byte;
				}
				stcol = tempsymb.u.variable.col;
				strow = tempsymb.u.variable.row;
				//store in the string the appearance of that cell variable
				GetAppearanceOfVariable(tempsymb.appearance, stcol, strow);
				pos+=4;
				tempsymb.type =4;    //operand code
				break;

			case 2:      //range:  8 byte range coordinates follow
			//copy in the 8 byte variable
				for(t = 0; t <8; t++)
					tempsymb.u.text[t] = rawbuf[pos+t];

				stcol  = tempsymb.u.range.stcol;
				strow  = tempsymb.u.range.strow;
				endcol = tempsymb.u.range.endcol;
				endrow = tempsymb.u.range.endrow;

				//store in the string the appearance of that range
				GetAppearanceOfRange(tempsymb.appearance, stcol, strow, endcol, endrow, colon);
				pos+=8;
				tempsymb.type = 4;    //operand code
				break;


			case 5:      //a 2 byte signed integer follows
			//copy in the 2 byte integer
				for(t = 0; t <2; t++)
					tempsymb.u.text[t] = rawbuf[pos+t];

				inum = tempsymb.u.ivalue;
				//store in the the string the appearance of that integer
				GetAppearanceOfNumber(tempsymb.appearance, code, inum, dnum);
				pos+=2;
				tempsymb.type =4;   //operand code
				break;

				default:   //for all other code get its appearance
							  //some codes have no appearance
					GetAppearanceOfOpCode(tempsymb.appearance, code);

					//If its a function store the count of the number
					//of args it takes. For fixed count functions get this
					//number from the lookup table; for variable
					//count founctions get the arg count number from the
					//next raw byte in the rawbuf
					if(code >= 31 && code <= 97)
					{
						t = codeTable[code -31];
						if(t == -1) //if a variable count: get from rawbuf
							t = rawbuf[pos++];  //get current, then inc pos

						tempsymb.argc = t;
						tempsymb.type = 1;      //function;
					}
					else if(code >=8 && code <=23)
						tempsymb.type = 2; //operator code

					//if its an operand its type code has already been done from
					//the cases 0, 1, 2 or 5 in switch statement above

					else if(code ==4)
						tempsymb.type =5;     //parantheses

					else if(code == 3)
						tempsymb.type =6;    //end of formula

					break;

		} //end of switch

		//If code is either 24-30, 50, 64-79, 98-255 then set
		//the type to 3 (ignore code means discard this symbol)
		if((code >= 24 && code <= 30) || (code == 50) ||
			(code >= 64 && code <= 79) || ((code >= 98) && (code <=255)))
			tempsymb.type = 3;

		if(tempsymb.type !=3) //if its not an ignore code then store it
		{
			postfix[symbcount] = tempsymb;
			symbcount++;
		}
	}while((code !=3) && (rawbuf[pos] !=0));     //keep storing symbols until end of rawbuf

	symblen = symbcount;

	return symblen;     //r # of symbols in the postfix[] symb array
}
//------------------------------------------------------------------------
//Given a postfix formula in inbuf convert it into a infix string
//and copy the infix string into outbuf
//A postfix formula is a formula in RPN.
//An infix formula is the original format of the formula
//in the standard way
// For example,  suppose there is wks spreadsheet file called sheet1.wks
// which contains the formula in cell A1 in postfix notation:
//  	A1 = 15 - 7 8 * 9 2 @round -
// then when this is converted back into infix notation it
// will look like this:
// 	A1 = 15-@Round(7*8*9, 2)
//Exit:
// if ax =0 it means the formula contains an error and therefor
//          cannot be correctly translated to infix notation
int Decomp::ConvertPostfixToInfix(char *inbuf, char *outbuf, int colon)
{
	Symb tempsymb;
	Symb s1;
	Symb s2;
	int len, t, done =0;
	unsigned int pos;
	char tempbuf[100];
	outbuf[0] =0;

	//break the formula up into symbols and store each symbol object in
	//the postfix[] symbol array
	len = ConvertRawToPostfix(inbuf, colon);
	if(!len) goto ex;
	pos = -1;
	do
	{
		pos++;
		tempsymb = postfix[pos];
		//if it is an operand or a function that takes no args
		//then push it on the stack
		if(tempsymb.type == 4 || (tempsymb.type ==1 && tempsymb.argc ==0))
		{
			Push(&tempsymb);
		}
		else  //its either an operator or a function that takes args
				//or the end symbol
		{
			switch(tempsymb.type)
			{
				case 2:  //an operator: either binary or unary
					//if its unary - or +
					if(tempsymb.code == 8 || tempsymb.code ==23)
					{
						if(IsStackEmpty())
						{
							strcpy(tempbuf, tempsymb.appearance);
							strcat(tempbuf, outbuf);
							strcpy(outbuf, tempbuf);
							goto ex;
						}
						//pop the operand symbol from the stack and prefix
						//it with the unary symbol
						s1 = *Pop();
						strcpy(tempbuf, tempsymb.appearance);  //unary symb
						strcat(tempbuf, s1.appearance);   //the operand
						strcpy(s1.appearance, tempbuf);   //new appearance of
																			  //the operand
						Push(&s1);         //push operand back on the stack
						break;
					}
					//its not a unary - or unary + but it is an operator
					//therefore pop the two operands from the stack
					//enter the operator symbol between them and push
					//the last poped operand back on the stack
					if(IsStackEmpty()) goto ex;   //error
					s1 = *Pop();
					if(IsStackEmpty()) goto ex;   //error
					s2 = *Pop();
					strcat(s2.appearance, tempsymb.appearance);
					strcat(s2.appearance, s1.appearance);
					Push(&s2);
					break;   //case 2


				case 1:
					//Its a function.
					//If there are no args in the function just push it
					//on the stack,
					//else based on the argc count pop each operand
					//from the stack and produce the textulised version
					//of the function, enclosing the args string in parentheses
					//then store the result as a new function sym on the stack.
					if(tempsymb.argc == 0)
					{
						Push(&tempsymb);
						break;  //case 1
					}
					//else based on the argc count pop each operand
					//from the stack and produce the textulised version
					//of the function, enclosing the args string in parentheses
					//then store the result as a new function sym on the stack.
					strcpy(tempbuf, ")");
					for(t = 0; t < tempsymb.argc; t++)
					{
						s1 = *Pop();       //the right most arg comes first
						strcat(s1.appearance, tempbuf);
						strcpy(tempbuf, ",");
						strcat(tempbuf, s1.appearance);

					}
					strcat(tempsymb.appearance, "(");
					strcat(tempsymb.appearance, &tempbuf[1]);
					Push(&tempsymb);
					break;  //case 1

				 case 5:  //its a closing parenthese
					//pop the last arg from the stack and embrace it
					if(!IsStackEmpty())   //if stack not empty
					{
						s1 = *Pop();
						strcpy(tempbuf, "(");
						strcat(tempbuf, s1.appearance);
						strcpy(s1.appearance, tempbuf);
						strcat(s1.appearance, ")");
						Push(&s1);
						break;
					}
					else goto ex;   //its a brace but the stack is empty: error

				 case 6:   //end of formula
				 //the resulting symbol should be on the stack
				 if(!IsStackEmpty())
				 {
					s1 = *Pop();
					strcpy(outbuf, s1.appearance);
					done = 1;  //flag: end while() loop
					break;
				 }
				 else goto ex;

			} //end of switch

		} //end of else

	}while (!done);


ex:
	return strlen(outbuf);
}
//------------------------------------------------------------------------
//Assuming that a Matrix spreadsheet file has been created for writing to
//this function writes out the following preliminary information
// 1 The Matrix file identification string
// 2 "2600\n" a temporary dummy # representing the last nonblank row
// 3 string of 26 letters +"\n" = 26 col widths
// 4 4-char string + "\n" representing the background and foreground of the
//   two alt rows
// 5 a temporary dummy string representing the count of the number of cells
//	  written.
//   When the formulas of all the cells have been this count number will
//   be rewritten correctly. the first time it is written as a dummy
//   place holder.
int Decomp::WriteMatrixPreliminaryInfo(FILE *outfp)
{
	int len;

	beg[0] =0;
	strcpy(linebuf1, "Matrix spreadsheet v2.0\n");
	len = strlen(linebuf1);
	fwrite(linebuf1, len, 1, outfp);

	beg[1] = len;    //pos where the 2nd line begins
	strcpy(linebuf1, "xxxxx\n");     //5 bytes + lf = (last row *26)
	len = strlen(linebuf1);
	fwrite(linebuf1, len, 1, outfp);

	beg[2] = len +beg[1];  //pos where 3rd line begins
	strcpy(linebuf1, "KKKKKKKKKKKKKKKKKKKKKKKKKK\n");  //26 bytes +lf colwidths
	len = strlen(linebuf1);
	fwrite(linebuf1, len, 1, outfp);

	beg[3] = len +beg[2]+beg[1];  //pos where 4th line begins
	strcpy(linebuf1, "DAHA\n");   //4 bytes + lf = 2 alt rows colours
	len = strlen(linebuf1);
	fwrite(linebuf1, len, 1, outfp);

	beg[4] = len + beg[3]+beg[2] +beg[1];  //pos where 5th line begins
	strcpy(linebuf1,"xxxxx\n");    //5 bytes + lf
											 //count of the number of cells written
	len = strlen(linebuf1);
	fwrite(linebuf1, len, 1, outfp);


	return 0;
}
//------------------------------------------------------------------------
//replace the dummy info with proper info
int Decomp::WriteMatrixPreliminaryInfo(FILE *outfp,
													int cell_count, int lastrow)
{
	long int pos;
	int len, t;

	sprintf(linebuf1, "%5d\n", lastrow*26);
	pos = (long int) beg[1];
	fseek(outfp, pos, SEEK_SET);    //rewind file  to beg of 2nd line
	fwrite(linebuf1, 6, 1, outfp);

	for(t = 0; t<26; t++)
		linebuf1[t] = colwidths[t]+'A';

	strcat(linebuf1, "\n");
	fwrite(linebuf1, 27, 1, outfp);


	strcpy(linebuf1, "DAHA\n");   //4 bytes + lf = 2 alt rows colours
	fwrite(linebuf1, 5, 1, outfp);

	sprintf(linebuf1, "%5d\n", cell_count);
	fwrite(linebuf1, 6, 1, outfp);


	return 0;
}
//------------------------------------------------------------------------
//The the current cell convert Lotus properties to
//Matrix
// Entry:
//  cf = the Lotus cell format.
// cx, cy = the location of the Matrix cell
int Decomp::ConvertLotusPropertiesToMatrix(int cx, int cy, Format cf)
{
	unsigned int loc = cy*26+cx;

	//if(cf.protect)
	//	sheet[loc].u.locked =1;


	if(cf.fmt_type == 7)    //if its a special format
	{
		if(cf.decimals == 5)  //text
			sheet[loc].u.type =1;
		if(cf.decimals == 6)  //hidden
			colwidths[cx] =0;

	}
	else   //not specal format
	{
		if(cf.fmt_type == 3)  //percent
			sheet[loc].u.percent =1;

		if(cf.fmt_type == 4)  //comma
			sheet[loc].u.commas =1;

		if(cf.decimals >9)
			cf.decimals =9;
		sheet[loc].u.decplaces = cf.decimals;

	}

	return 0;
}
//------------------------------------------------------------------------
//Convert a Lotus "*.wks" spreadsheet file to a matrix file
//Flg = 0 if successful, else flg <0
int Decomp::LotusToMatrixFile(char *inname, int colon)
{
	char  outname[80];
	char tempbuf[90];
	char rawbuf1[160];
	char chr;
	char *p;
	long file_pos, offset;
	unsigned int word, version, loc, x, y;
	int cell_count=0, lastrow =1;
	int inum, t, i, flg = -1;     //assume not successful in creating Matrix file
	double dnum;
	Integer Int;         //7 byte struct for integer constant record
	Double  Dou;         //13 byte struct for double constant record
	Label Lab;
	Formula Form;
	Header h;
	FILE *infp, *outfp;

	strcpy(outname, inname);
	p = strrchr(outname, '.');
	if(p) //change the extension of the output file name from ".wks" to ".mtx"
	{
		*p = '\0';
	}
	strcat(outname, ".mtx");

	infp = fopen(inname, "rb");
	if(infp ==NULL)
	{
		return -1;  //unable to open Lotus file for reading
	}
	outfp = fopen(outname, "wb");
	if(outfp == NULL)
	{
		fclose(infp);
		return -2;     //unable to Create a Matrix file

	}
	offset = 0L;
	fseek(infp, 0L, SEEK_SET);    //rewind file
	fread(&h, sizeof(h), 1, infp);
	if(h.type) goto ex;   //error: should be 0, ie., beg-of-file
	if(h.len != 2) goto ex;
	offset = (long) h.len;
	//fseek(infp, offset, SEEK_CUR);    //skip past header
	fread(&version, 2, 1, infp);
	if(version < 1028) goto ex;
	if(version == 2571 || version == 8711 ) goto con;
	if(version > 1030) goto ex;  //not a Lotus file

	WriteMatrixPreliminaryInfo(outfp);


con:   //read in next header
	fread(&h, 4, 1, infp);
	word = h.type;
	switch(h.type)
	{
		case 6:
			//The range of the wordsheet.
			//If the wordsheet is empty it
			fread(&globalRange, 8, 1, infp);
			if(globalRange.stcol == -1) goto ex;  //wordsheet empty
			goto con; //next header

		case 7:
		//global col widths.
		//read in the global colwidths into colwidths array
		//if any width is greater than 60 or less less than 0 set
		//it to 60.
		//colwidth is out of bounds A to Z (0 -25) ignore it
			fread(&tempbuf, h.len, 1, infp);
			word = tempbuf[7]*256+tempbuf[6];  //global col width
			if(word > 60) word =60;
			for(t = 0; t< 26; t++) colwidths[t] = word;
			goto con; //next header

		case 8: //a particular col width
		//Read in a particular col width. If it refers to a col
		//outside Matrix's range 0 -25 ignore it
		//if its width is greater than 60 set it to 60
			fread(&tempbuf, 3, 1, infp);
			word = tempbuf[1]*256+tempbuf[0];  //col
			if(word > 25) goto con;
			if(tempbuf[2] > 60) tempbuf[2] =60;
			colwidths[word] = tempbuf[2];
			goto con;

	  case 13:      //integer follows
		  fread(&Int, 7, 1, infp);      //read in 7 byte integer record
		  if(Int.var.col >25) goto con;
		  inum = Int.i;
		  if(Int.var.row >400) goto con;
		  GetAppearanceOfVariable(tempbuf, Int.var.col, Int.var.row, 1);
		  if(lastrow-1 < Int.var.row) lastrow = Int.var.row +1;
		  strcat(tempbuf, "=");
		  i = strlen(tempbuf);
		  //convert integer to string
		  GetAppearanceOfNumber(&tempbuf[i], 5, inum, dnum);
		  strcat(tempbuf, "\n");
		  fwrite(tempbuf, strlen(tempbuf), 1, outfp);
		  cell_count++;
		  ConvertLotusPropertiesToMatrix(Int.var.col, Int.var.row, Int.fmt);
		  loc = Int.var.row*26+Int.var.col;
		  sheet[loc].u.type = 2;     //number type
		  goto con;


	  case 14: //double

		  fread(&Dou, 13, 1, infp);      //read in 13 byte double record
		  if(Dou.var.col >25) goto con;
		  dnum = Dou.d;
		  if(Dou.var.row >400) goto con;
		  GetAppearanceOfVariable(tempbuf, Dou.var.col, Dou.var.row, 1);
		  if(lastrow-1 < Dou.var.row) lastrow = Dou.var.row +1;

		  strcat(tempbuf, "=");
		  i = strlen(tempbuf);
		  //convert integer to string
		  GetAppearanceOfNumber(&tempbuf[i], 0, inum, dnum);
		  strcat(tempbuf, "\n");
		  fwrite(tempbuf, strlen(tempbuf), 1, outfp);
		  cell_count++;
		  ConvertLotusPropertiesToMatrix(Dou.var.col, Dou.var.row, Dou.fmt);
		  loc = Dou.var.row*26+Dou.var.col;
		  sheet[loc].u.type = 2;     //number type
		  goto con;

	  case 15: //label of variable length and suffixed with 0
		  fread(&Lab, 5, 1, infp);      //read in 5 byte label record
		  fread(rawbuf1, h.len-5, 1, infp);      //and then label string
		  if(Lab.var.col >25)  goto con;   //col out of Matrix's range
													  //skip it

		  if(Lab.var.row >400) goto con;
		  GetAppearanceOfVariable(tempbuf, Lab.var.col, Lab.var.row, 1);
		  if(lastrow-1 < Lab.var.row) lastrow = Lab.var.row +1;
		  ConvertLotusPropertiesToMatrix(Lab.var.col, Lab.var.row, Lab.fmt);
		  loc = Lab.var.row*26+Lab.var.col;
		  strcat(tempbuf, "=");
		  if(rawbuf1[0] == 34 ) //right justify
		  {
			  rawbuf1[0] = 39;
			  sheet[loc].u.allign =3;  //Matrix code for right
		  }
		  else if(rawbuf1[0] == '^')
		  {
			 rawbuf1[0] = 39;
			 sheet[loc].u.allign = 2;   //Matrix code for centre
		  }

		  strcat(tempbuf, rawbuf1);

		  strcat(tempbuf, "\n");
		  fwrite(tempbuf, strlen(tempbuf), 1, outfp);
		  cell_count++;
		  sheet[loc].u.type = 1;     //text
		  goto con;

	 case 16:  //formula

		  fread(&Form, 15, 1, infp);      //read in 15 byte fixed part of the
													//formula record
		  fread(rawbuf1, h.len-15, 1, infp);
		  if(Form.var.col >25)  goto con;
		  if(Int.var.row >400) goto con;

		  GetAppearanceOfVariable(tempbuf, Form.var.col, Form.var.row, 1);
		  if(lastrow-1 < Form.var.row) lastrow = Form.var.row +1;

		  strcat(tempbuf, "=");
		  i = strlen(tempbuf);
		  cell_col = Form.var.col;
		  cell_row = Form.var.row;
		  ConvertPostfixToInfix(rawbuf1, &tempbuf[i], colon);
		  strcat(tempbuf, "\n");
		  fwrite(tempbuf, strlen(tempbuf), 1, outfp);
		  cell_count++;
		  ConvertLotusPropertiesToMatrix(Form.var.col, Form.var.row, Form.fmt);
		  loc = Form.var.row*26+Form.var.col;
		  sheet[loc].u.type = 2;     //number type
		  goto con;


	  case 1: //end of file record
		 flg =0;    // successful
		 //write out the cell properties of all the rows upto last row
		 strcpy(tempbuf, "Properties\n");
		 fwrite(tempbuf, strlen(tempbuf), 1, outfp);
		 for(y = 0; y< lastrow; y++)
		 {
			for(x = 0; x <26; x++)
			{
				for(t = 0; t <3; t++)
				{
					tempbuf[x*3+t] = sheet[y*26+x].mem[t]+1;
				}
			}
			tempbuf[26*3] =0;
			strcat(tempbuf, "\n");
			fwrite(tempbuf, 26*3+1, 1, outfp);

		 }

		 //rewrite certain Matrix preliminary info again
		 WriteMatrixPreliminaryInfo(outfp, cell_count, lastrow);

		 goto ex;


	  default:
		 //Record header of uninteresting type: skip past the
		 //record's body to set the file point to the next record header
		offset = (long) h.len;
		fseek(infp, offset, SEEK_CUR);    //skip past
		goto con;

	}



ex:
	fclose(outfp);
	fclose(infp);

	return flg;
}
//-----------------------------------------------------------------------





